# frozen_string_literal: true

# This class initializes the parameters and variables for the context of Transaction/Span

require 'stackify_apm/context/prefix'
require 'stackify_apm/context/request'
require 'stackify_apm/context/request/headers'
require 'stackify_apm/context/request/socket'
require 'stackify_apm/context/request/url'
require 'stackify_apm/context/response'

module StackifyRubyAPM
  # @api private
  class Context
    include NaivelyHashable

    attr_accessor :request, :response, :aws, :category, :prefix
    attr_reader :custom, :tags

    def initialize
      @custom = {}
      @tags = {}
      @prefix = Context::Prefix.new
    end

    # add aws context to context instance
    #
    # values {arn}
    def add_aws_context ctx
      @aws = ctx
    end
  end
end
