# frozen_string_literal: true

module StackifyRubyAPM
  class Context
    # @api private
    class Prefix
      include NaivelyHashable

      attr_accessor :response_body, :request_body
      attr_reader :response_headers, :request_headers

      def request_headers=(headers)
        @request_headers = to_json_list(headers)
      end

      def response_headers=(headers)
        @response_headers = to_json_list(headers)
      end

      private
      def to_json_list(header)
        list_header = []
        header.each do |key, value|
          list_header << {key => value}
        end
        list_header.to_json
      end
    end
  end
end
