# frozen_string_literal: true

module StackifyRubyAPM
  # @api private
  class Context
    # @api private
    class Request
      # @api private
      class Headers
        include NaivelyHashable

        def initialize(req)
          @values = build_headers req
        end

        attr_reader :values

        def build_headers req
          env = req.env
          headers = Hash[*env.select {|k,v| k.start_with? 'HTTP_'}
            .collect {|k,v| [k.sub(/^HTTP_/, ''), v]}
            .collect {|k,v| [k.split('_').collect(&:capitalize).join('-'), v]}
            .sort
            .flatten]
          return headers
        end
      end
    end
  end
end
