# frozen_string_literal: true

require 'stackify_apm/stacktrace'
require 'stackify_apm/context'
require 'stackify_apm/error/exception'
require 'stackify_apm/error/log'

module StackifyRubyAPM
  # @api private
  class Error
    def initialize(culprit: nil)
      @id = SecureRandom.uuid
      @culprit = culprit
      time_now = Time.now

      @timestamp = time_now.to_f * 1000
      @context = Context.new

      @transaction_id = nil
    end

    attr_accessor :id, :culprit, :exception, :log, :transaction_id, :context
    attr_reader :timestamp
  end
end
