# frozen_string_literal: true

# Starts the Monkey patch for the generated log by not including the header
#
#
# @param file
# @removed the header of the generated log
require 'logger'
module StackifyRubyAPM
  # @api private
  class StackifyLogger < Logger
    # rubocop:disable Style/NumericLiterals
    # rubocop:disable Style/GuardClause
    # rubocop:disable Metrics/ParameterLists
    # rubocop:disable Lint/UnusedMethodArgument
    def initialize(logdev,
                   shift_age = 0,
                   shift_size = 1048576,
                   level: DEBUG,
                   progname: nil,
                   formatter: nil,
                   datetime_format: nil,
                   shift_period_suffix: '%Y%m%d')
      super(nil) # this prevents it from initializing a LogDevice
      @logdev = nil
      if logdev
        new_logdev = logdev
        if logdev.instance_of? String
          temp_filename = logdev.gsub('-1.log', '')
          new_logdev = temp_filename + '-1.log'
        end
        begin
          @logdev = LogDevice.new(new_logdev, shift_size: shift_size)
        rescue StandardError => e
          puts "Stackify Profiler unable to access [" + logdev + "]"
        end
      end
    end
    require 'stackify_apm/logger/log_device'
  end
end
