# frozen_string_literal: true

# Starts the Monkey patch for the generated log by not including the header
#
#
# @param file
# @removed the header of the generated log
require 'logger'
module StackifyRubyAPM
  # @api private
  class StackifyLogger < Logger
    # rubocop:disable Style/NumericLiterals
    # rubocop:disable Style/GuardClause
    def initialize(logdev, _shift_age = 0, shift_size = 1048576)
      super(nil) # this prevents it from initializing a LogDevice
      @logdev = nil
      if logdev
        new_logdev = logdev
        if logdev.instance_of? String
          temp_filename = logdev.gsub('-1.log', '')
          new_logdev = temp_filename + '-1.log'
        end
        begin
          @logdev = LogDevice.new(new_logdev, shift_size: shift_size)
        rescue StandardError => e
          puts "Stackify Profiler unable to access [" + logdev + "]"
        end
      end
    end

    require 'stackify_apm/logger/log_device'
  end
end
