# frozen_string_literal: true

require 'json'
# After the spans are being build it will serialize or rebuild or reformat the spans created into json format
module StackifyRubyAPM
  # @api private
  module Serializers
    # @api private
    class Serializer
      def initialize(config)
        @config = config
      end

      private

      def micros_to_time(micros)
        Time.at(ms(micros) / 1_000)
      end

      def ms(micros)
        micros.to_f / 1_000
      end
    end
  end
end

require 'stackify_apm/serializers/transactions'
require 'stackify_apm/serializers/errors'
