# frozen_string_literal: true

# This class handle the selection of the Transport.

module StackifyRubyAPM
  # @api private
  class TransportSelector
    attr_reader :transport

    def initialize(config)
      @transport =
        case config.transport.strip.downcase
        when StackifyRubyAPM::UNIX_SOCKET
          StackifyRubyAPM::UnixSocketClient.new(config)
        when StackifyRubyAPM::AGENT_HTTP
          StackifyRubyAPM::AgentHTTPClient.new(config)
        when StackifyRubyAPM::LOGGING
          StackifyRubyAPM::AWSLoggerClient.new(config)
        else
          StackifyRubyAPM::LogClient.new(config)
        end
    end
  end
end
